Attribute VB_Name = "modMain"
' ------------------------------------------------------
' Name:     Main.BAS
' Copyright (c) 1997 Slightly Tilted Software
' By:       L.J. Johnson       Date: 06-07-1997
' Comments: Contains Sub Main (startup of the
'           service), ServiceMain (primary thread),
'           Handler (the callback function), plus
'           some support functions for the service
' ------------------------------------------------------
Option Explicit

' ---------------------------------------------
' Used for Event logging
' ---------------------------------------------
Private Const mconstModName = "A_Service.modMain"

' ---------------------------------------------
' Apparently, Microsoft just left these out
' ---------------------------------------------
Public Const vbLogEventTypeError = 1         ' Error.
Public Const vbLogEventTypeWarning = 2       ' Warning.
Public Const vbLogEventTypeInformation = 4   ' Information.

' ---------------------------------------------
' The modMain talks only (directly) with
'     MyService
' ---------------------------------------------
Public objGenericService         As GenericService

Public Const PROJECT_NAME = "MySCM"

' ---------------------------------------------
' Used by the APIMessageBox function
' ---------------------------------------------
Private Const MB_SERVICE_NOTIFICATION = &H200000
Private Const MB_SERVICE_NOTIFICATION_351 = &H40000

' ---------------------------------------------
'
' ---------------------------------------------
Public Type ObjData
   ServiceName       As String
   DisplayName       As String
   CurrentStateStr      As Long
   ServiceType       As String
   ControlsAccepted  As Long
   StartTypeStr         As Long
   ErrorControl      As String
   BinaryPath        As String
End Type

Private Type OSVERSIONINFO
   dwOSVersionInfoSize As Long
   dwMajorVersion As Long
   dwMinorVersion As Long
   dwBuildNumber As Long
   dwPlatformId As Long
   szCSDVersion As String * 128      '  Maintenance string for PSS usage
End Type

Private Declare Function GetVersionEx _
   Lib "kernel32" Alias "GetVersionExA" _
   (uVersionInformation As OSVERSIONINFO) As Long
Private Declare Function MessageBox _
   Lib "user32" Alias "MessageBoxA" _
   (ByVal hwnd As Long, _
    ByVal lpText As String, _
    ByVal lpCaption As String, _
    ByVal wType As Long) As Long

' ---------------------------------------------
' Used by the PointerToString and ServiceMain
'     functions
' ---------------------------------------------
Private Declare Function lstrlen _
   Lib "kernel32" Alias "lstrlenA" _
   (ByVal lpstring As Long) As Long
Private Declare Sub CopyMem _
   Lib "kernel32" Alias "RtlMoveMemory" _
   (lpvDest As Any, _
    lpvSource As Any, _
    ByVal cbCopy As Long)

' *********************************************
' Kludge: This will return the address of any
'         function passed to it with the
'         AddressOf keyword.
' *********************************************
Public Function FuncPtr(ByVal xlngAddress As Long) As Long
   On Error Resume Next
   FuncPtr = xlngAddress
   On Error GoTo 0
End Function

' *********************************************
' The program starts here
' *********************************************
Public Sub Main()
   On Error Resume Next
   Const consProcName = "Main"
   Dim strCmdLine       As String
   
   ' ------------------------------------------
   ' Get the command line
   ' ------------------------------------------
   strCmdLine = Command$()
   
   ' ------------------------------------------
   ' Insubstantiate the service and pass the
   '     command line
   ' ------------------------------------------
   Set objGenericService = New GenericService
   
   frmMySCM.Show vbModeless
   
   On Error GoTo 0
End Sub

' *********************************************
' Turns a LPSTR into a Visual Basic String.
' *********************************************
Private Function PointerToString(ByVal xlngPrtString As Long) As String
   Dim lngStrLen     As Long
   Dim strRtn        As String
   
   ' ------------------------------------------
   ' Check if NULL string.
   ' ------------------------------------------
   If xlngPrtString Then
      
      ' ---------------------------------------
      ' Get the length of the string.
      ' ---------------------------------------
      lngStrLen = lstrlen(xlngPrtString)
      
      If lngStrLen Then
         ' ------------------------------------
         'Create a string with the same size,
         '  and copy the data into it.
         ' ------------------------------------
         strRtn = Space$(lngStrLen)
         CopyMem ByVal strRtn, ByVal xlngPrtString, lngStrLen
         PointerToString = strRtn
      End If
   
   End If

End Function

Public Function EnumMain() As Boolean
   
   EnumMain = True
End Function

' -------------------------------------------------
' Note:  Passing strings to function, the trailing
'        Chr$(0)'s will be truncated -- need to add
'        them back
' Also, in one case, we will be passing only 2
'        characters to the function in order to get
'        the low-order number for EventID (so it
'        will be the same as shown in the Event
'        Viewer)
' -------------------------------------------------
Public Function CVL(xstrNumber As String) As Long
   Dim plngTmp    As Long

   Select Case Len(Trim(xstrNumber))
      Case 0
         Debug.Print "Illegal function call"
         Exit Function
      Case 1
         xstrNumber = xstrNumber & Chr$(0) & Chr$(0) & Chr$(0)
      Case 2
         xstrNumber = xstrNumber & Chr$(0) & Chr$(0)
      Case 3
         xstrNumber = xstrNumber & Chr$(0)
      Case Is > 4
         Debug.Print "Illegal function call"
         Exit Function
   End Select

   CopyMem plngTmp, ByVal xstrNumber, 4
   CVL = plngTmp

End Function
