VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "NTServers"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
      
' ------------------------------------------------
' Constants for type of computer
' ------------------------------------------------
Private Const SV_TYPE_WORKSTATION = &H1&
Private Const SV_TYPE_SERVER = &H2&
Private Const SV_TYPE_SQLSERVER = &H4&
Private Const SV_TYPE_DOMAIN_CTRL = &H8&
Private Const SV_TYPE_DOMAIN_BAKCTRL = &H10&
Private Const SV_TYPE_TIME_SOURCE = &H20&
Private Const SV_TYPE_AFP = &H40&
Private Const SV_TYPE_NOVELL = &H80&
Private Const SV_TYPE_DOMAIN_MEMBER = &H100&
Private Const SV_TYPE_PRINTQ_SERVER = &H200&
Private Const SV_TYPE_DIALIN_SERVER = &H400&
Private Const SV_TYPE_XENIX_SERVER = &H800&
Private Const SV_TYPE_SERVER_UNIX = &H800&
Private Const SV_TYPE_NT = &H1000&
Private Const SV_TYPE_WFW = &H2000&
Private Const SV_TYPE_SERVER_MFPN = &H4000&
Private Const SV_TYPE_SERVER_NT = &H8000&
Private Const SV_TYPE_POTENTIAL_BROWSER = &H10000
Private Const SV_TYPE_BACKUP_BROWSER = &H20000
Private Const SV_TYPE_MASTER_BROWSER = &H40000
Private Const SV_TYPE_DOMAIN_MASTER = &H80000
Private Const SV_TYPE_SERVER_OSF = &H100000
Private Const SV_TYPE_SERVER_VMS = &H200000
Private Const SV_TYPE_WINDOWS = &H400000
Private Const SV_TYPE_ALTERNATE_XPORT = &H20000000
Private Const SV_TYPE_LOCAL_LIST_ONLY = &H40000000
Private Const SV_TYPE_DOMAIN_ENUM = &H80000000
Private Const SV_TYPE_ALL = &HFFFF

' ------------------------------------------------
' Type used by NetServerEnum
' ------------------------------------------------
Private Type SERVER_INFO_101
    wki101_platform_id As Long
    wki101_servername As Long
    wki101_langroup As Long
    wki101_ver_major As Long
    wki101_ver_minor As Long
    wki101_lanroot As Long
End Type
      
' ------------------------------------------------
' API declarations
' ------------------------------------------------
Private Declare Function NetServerEnum Lib "Netapi32" _
      (ByVal sServerName As String, _
       ByVal lLevel As Long, _
       vBuffer As Long, _
       lPreferedMaxLen As Long, _
       lEntriesRead As Long, _
       lTotalEntries As Long, _
       ByVal vServerType As Long, _
       ByVal sDomain As String, _
       vResume As Long) As Long
Private Declare Function NetApiBufferFree _
      Lib "Netapi32" _
      (ByVal lBuffer&) As Long
Private Declare Sub lstrcpyW _
      Lib "kernel32" _
      (vDest As Any, ByVal vSrc As Any)
Private Declare Sub RtlMoveMemory _
      Lib "kernel32" _
      (dest As Any, vSrc As Any, ByVal lSize&)
Private Declare Function GetComputerName _
      Lib "kernel32" Alias "GetComputerNameA" _
      (ByVal lpBuffer As String, _
       nSize As Long) As Long

' ------------------------------------------------
'
' ------------------------------------------------
Public Function GetServers() As Variant
   Dim pstrServerName         As String
   Dim pstrComputerName       As String
   Dim pstrDomainName         As String
   Dim pbytBuf(512)           As Byte
   Dim plngRtn                As Long
   Dim plngSrvInfoRtn         As Long
   Dim plngPreferedMaxLen     As Long
   Dim plngNumEntriesRead     As Long
   Dim plngTotalEntries       As Long
   Dim plngServerType         As Long
   Dim plngResume             As Long
   Dim plngCnt                As Long
   Dim lSeverInfo101StructPtr As Long
   Dim plngServEnumLevel      As Long
   Dim plngPos                As Long
   Dim ptypServerInfo101      As SERVER_INFO_101
   Dim pstrLocalComputerName  As String
   Dim plngLenComputerName    As Long
   Dim pvntComputers()        As Variant
   
   
   ' ---------------------------------------------
   ' Get the name of the local computer
   ' ---------------------------------------------
   pstrLocalComputerName = Space$(512)
   plngLenComputerName = Len(pstrLocalComputerName)
   plngRtn = GetComputerName(pstrLocalComputerName, _
                        plngLenComputerName)
   If plngRtn > 0 Then
      pstrLocalComputerName = Trim$(Mid$(pstrLocalComputerName, 1, plngLenComputerName))
   End If
   
   
   ' ---------------------------------------------
   ' Initialize the variables
   ' ---------------------------------------------
   pstrComputerName = vbNullString
   pstrServerName = vbNullString
   pstrDomainName = vbNullString
   plngServEnumLevel = 101
   plngServerType = SV_TYPE_NT
   
   
   ' ---------------------------------------------
   ' Call NetServerEnum to get a list of Servers
   ' ---------------------------------------------
   plngRtn = NetServerEnum(pstrServerName, _
         plngServEnumLevel, plngSrvInfoRtn, _
         plngPreferedMaxLen, plngNumEntriesRead, _
         plngTotalEntries, plngServerType, _
         pstrDomainName, plngResume)
   
   
   ' ---------------------------------------------
   ' NetServerEnum Index is 1 based -- iterate
   '     thru the return values to get the
   '     NT servers and workstations
   ' ---------------------------------------------
   plngCnt = 1
   lSeverInfo101StructPtr = plngSrvInfoRtn
           
   ReDim pvntComputers(1 To plngTotalEntries)
   
   
   For plngCnt = 1 To plngTotalEntries
      
      pstrComputerName = ""
           
      RtlMoveMemory ptypServerInfo101, ByVal lSeverInfo101StructPtr, Len(ptypServerInfo101)
   
      lstrcpyW pbytBuf(0), ptypServerInfo101.wki101_servername
      On Error Resume Next
      pstrComputerName = pbytBuf
      plngPos = InStr(pstrComputerName, vbNullChar)
      If plngPos > 0 Then
         pstrComputerName = Mid$(pstrComputerName, 1, plngPos - 1)
      End If
      
      ' ------------------------------------------
      ' If it's the local computer, then
      '     add the '(Local' suffice and
      '     put it first in the list
      ' ------------------------------------------
      If UCase$(pstrLocalComputerName) = UCase$(pstrComputerName) Then
         pstrComputerName = pstrComputerName & " (Local)"
      End If
      
      pvntComputers(plngCnt) = pstrComputerName
      
      lSeverInfo101StructPtr = lSeverInfo101StructPtr + Len(ptypServerInfo101)
   
   Next plngCnt
   
   
   plngRtn = NetApiBufferFree(plngSrvInfoRtn)
 
   GetServers = pvntComputers

End Function

