VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ObjectData"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' ------------------------------------------------------
' Name: ObjectData.CLS (ObjectData)
' Copyright (c) 1997 Slightly Tilted Software
' By: L.J. Johnson       Date: 05-11-1997
' Comments:    ObjectData holds 2 variant arrays, one
'              for the column information, and one for
'              the data
' ------------------------------------------------------
Option Base 1
Option Explicit


' ------------------------------------------------------
' The private CLASS_NAME is used in each module for the
'     RaiseError call
' ------------------------------------------------------
Private Const CLASS_NAME = PROJECT_NAME & "." & "ObjectData"

Private mlngNumRows                 As Long
Private mlngNumCols                 As Long
Private mDataArray()                As Variant
Private mColumnArray()              As Variant

' ---------------------------------------------
' Passed a row and column, retrieve the data
'     for that item
' ---------------------------------------------
Public Function Item(xlngRow As Long, xlngCol As Long) As Variant
   On Error GoTo ItemErr
   Const constModName = "Item"

   Item = mDataArray(xlngRow, xlngCol)
   
   Exit Function
   
ItemErr:
   If Err.Number > 0 Then
      ' Set to this module
      Err.Source = CLASS_NAME & ":" & constModName
   Else
      ' We are just regenerating
   End If
   
   'Call RaiseError(Err.Number, _
                   Err.Source, _
                   Err.Description)
End Function

' ---------------------------------------------
' You *MUST* pass the number of rows and columns
'     to the Initialize function
' ---------------------------------------------
Public Sub Initialize(xlngNumCols As Long, xlngNumRows As Long)
   On Error GoTo InitializeErr
   Const constModName = "Initialize"
   
   ' ------------------------------------------
   ' Must have some columns passed
   ' ------------------------------------------
   If xlngNumCols < 1 Then
      On Error GoTo 0
      'Call RaiseError(PSAPI_NO_COLUMNS_ERROR, _
               CLASS_NAME & ":" & constModName, _
               ErrStr(PSAPI_NO_COLUMNS_ERROR))
      Exit Sub
   End If
   

   ' ------------------------------------------
   ' Must have some rows passed
   ' ------------------------------------------
   If xlngNumRows < 1 Then
      On Error GoTo 0
      'Call RaiseError(PSAPI_NO_ROWS_ERROR, _
               CLASS_NAME & ":" & constModName, _
               ErrStr(PSAPI_NO_ROWS_ERROR))
      Exit Sub
   End If
   
   
   ' ------------------------------------------
   ' Initialize the array
   ' ------------------------------------------
   mlngNumCols = xlngNumCols
   mlngNumRows = xlngNumRows
   
   ReDim mDataArray(1 To mlngNumRows, 1 To mlngNumCols) As Variant
   ReDim mColumnArray(1 To mlngNumCols, 2) As Variant
   
   Exit Sub
   
InitializeErr:
   If Err.Number > 0 Then
      ' Set to this module
      Err.Source = CLASS_NAME & ":" & constModName
   Else
      ' We are just regenerating
   End If
   
   'Call RaiseError(Err.Number, _
                   Err.Source, _
                   Err.Description)
End Sub

' ---------------------------------------------
' Add a column item -- must pass row and column
' ---------------------------------------------
Friend Sub AddColumnItem(xlngRow As Long, _
                         xlngCol As Long, _
                         xvntData As Variant)
   On Error GoTo AddItemErr
   Const constModName = "AddColumnItem"
   
   mColumnArray(xlngRow, xlngCol) = xvntData
   
   Exit Sub
   
AddItemErr:
   If Err.Number > 0 Then
      ' Set to this module
      Err.Source = CLASS_NAME & ":" & constModName
   Else
      ' We are just regenerating
   End If
   
   'Call RaiseError(Err.Number, _
                   Err.Source, _
                   Err.Description)
End Sub

' ---------------------------------------------
' Add a data item -- must pass row and column
' ---------------------------------------------
Friend Sub AddDataItem(xlngRow As Long, xlngCol As Long, xvntData As Variant)
   On Error GoTo AddItemErr
   Const constModName = "AddDataItem"
   
   mDataArray(xlngRow, xlngCol) = xvntData
   
   Exit Sub
   
AddItemErr:
   If Err.Number > 0 Then
      ' Set to this module
      Err.Source = CLASS_NAME & ":" & constModName
   Else
      ' We are just regenerating
   End If
   
   'Call RaiseError(Err.Number, _
                   Err.Source, _
                   Err.Description)
End Sub

' ---------------------------------------------
' Get a variant array of all the data passed
'     back to calling routine
' ---------------------------------------------
Public Property Get DataArray() As Variant
   On Error GoTo DataArrayErr
   Const constModName = "GetDataArray"
   
   DataArray = mDataArray()

   Exit Property

DataArrayErr:
   If Err.Number > 0 Then
      ' Set to this module
      Err.Source = CLASS_NAME & ":" & constModName
   Else
      ' We are just regenerating
   End If
   
   'Call RaiseError(Err.Number, _
                   Err.Source, _
                   Err.Description)
End Property

' ---------------------------------------------
' Get the names of all the columns
' ---------------------------------------------
Public Property Get ColumnArray() As Variant
   On Error GoTo ColumnArrayErr
   Const constModName = "GetColumnArray"
   
   ColumnArray = mColumnArray()
   
   Exit Property

ColumnArrayErr:
   If Err.Number > 0 Then
      ' Set to this module
      Err.Source = CLASS_NAME & ":" & constModName
   Else
      ' We are just regenerating
   End If
   
   'Call RaiseError(Err.Number, _
                   Err.Source, _
                   Err.Description)
End Property

' ---------------------------------------------
' Get the number of rows of the data
' ---------------------------------------------
Public Property Get DataRows() As Long
   On Error Resume Next
   
   ' ------------------------------------------
   ' Specifically, not Not produce an error
   ' Returning zero is an error
   ' ------------------------------------------
   DataRows = mlngNumRows
   On Error GoTo 0
   
End Property

' ---------------------------------------------
' Get the number of Columns of the data
' ---------------------------------------------
Public Property Get DataCols() As Long
   On Error Resume Next
   
   ' ------------------------------------------
   ' Specifically, not Not produce an error
   ' Returning zero is an error
   ' ------------------------------------------
   DataCols = mlngNumCols
   On Error GoTo 0

End Property
